import static java.lang.Math.*;
public class functorSpringForce extends Thread{
    final int start,
              end;
    final atom atomSrc[],
               atomDest[];

         
    //worldFunc f = new worldFunc();
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorSpringForce(final atom [] atomLst, final int _start, final int _end)
    {
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
            nuAtom = new atom(atomSrc[i]);

            //spring forces
            for (int j=0; j<nuAtom.linkQty;j++)
            {
                int k = nuAtom.linkedTo[j];
                //link removal ..... to optimize
                if (!a.linkedWith(atomSrc[k], nuAtom.id))
                    nuAtom = a.unLink(nuAtom, j);
                else
                {
                    //link not removal
                    double distCentersSQ = v.distSQ(nuAtom.pos, atomSrc[k].pos);  // returns SQdistance of atoms centers
                    if (distCentersSQ == 0)
                    {
                        //distCentersSQ = 0.1d;                     // case distance = 0, make it work. (could delete spring too or break)
                        nuAtom = a.unLink(nuAtom, j);
                    }
                    else
                    {
                        vector nuforce = a.repulseSQ(nuAtom, atomSrc[k], pow(nuAtom.lenght[j],2), distCentersSQ, nuAtom.rigidity,0.2);
                        nuAtom = a.addforce(nuAtom, nuforce);
                    }
                }
            }

            atomDest[i-start] = nuAtom;
        }
    }
}
